@startuml
hide empty description
skinparam backgroundColor transparent
skinparam linetype polyline
skinparam shadowing false
skinparam <<macro_state>> {
  padding 10
  StateFontSize 20
  StateBackgroundColor APPLICATION
  StateDescriptionColor White
}
state Search <<macro_state>>{
  state x <<choice>>
  x --> FeatureFilter: List Feature filters
  x --> OS_Filter: List OS filters
  x --> LicenseFilter: List License filters
  x --> TextFilter: Input text string
  FeatureFilter --> UpdateSearch: Add filter
  OS_Filter --> UpdateSearch: Add filter
  LicenseFilter --> UpdateSearch: Add filter
  TextFilter --> UpdateSearch: Add filter
}
state Software <<macro_state>>{
  state y <<choice>>
  y --> License:Load License info
  y --> Author:Load Author info
  y --> OS:Load OS info
  y --> ProgrammingLanguage:Load language info
  y -left-> Dependency:Load dependency info
}
state ExternalResources <<macro_state>>{
  state Wikidata
  state SPDX
  state OS_homepage
}

[*] -down-> x: Open website
UpdateSearch -down-> y: Click on software
Dependency -left-> TargetSoftware:Click on dependency
TargetSoftware --> y
License --> SPDX:Click on license
Author --> Wikidata:Click on author
OS --> OS_homepage:Click on OS
ProgrammingLanguage --> Wikidata:Click on language
@enduml
